unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, ekfunc,
  ekbasereport, ekrtf;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    EkRTF1: TEkRTF;
    EkUDFList1: TEkUDFList;
    Button2: TButton;
    RTFDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EkUDFList1Functions0Calculate(Sender: TObject; Args: TEkUDFArgs;
      ArgCount: Integer; UDFResult: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  (* check report template file *)
  if not FileExists(EkRTF1.InFile) then
  begin
    if RTFDialog.Execute then begin
       EkRTF1.InFile := RTFDialog.FileName;
    end else exit;
  end;

  (* create report *)
  EkRtf1.OutFile := 'EK_RTF_InMemoryBitmap_'+IntToStr(Random(10000))+'.doc';
  EkRtf1.ExecuteOpen([],SW_SHOW);

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.EkUDFList1Functions0Calculate(Sender: TObject;
  Args: TEkUDFArgs; ArgCount: Integer; UDFResult: TObject);
begin
 (* EK RTF User Defined Function DrawMemoryBitmap *)
 With UDFResult as TPicture do
 begin
    Bitmap.Width  := Image1.Width;
    Bitmap.Height := Image1.Height;
    Bitmap.Canvas.Draw(0,0,Image1.Picture.Graphic);
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Rectangle1 : TRect;
begin
  Rectangle1 := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.FillRect(Rectangle1);

  Image1.Canvas.Brush.Color := $070FF00;
  Image1.Canvas.Pen.Color := $070FF00;
  Image1.Canvas.Ellipse(40,20,200,180);

  Image1.Canvas.Brush.Color := $0FF6000;
  Image1.Canvas.Pen.Color := $0FF6000;
  Image1.Canvas.Rectangle(110,90,220,200);
end;

end.
